class_name SceneTools extends Object
## Tools for specialized operations in a scene


## Get the Node3D in the given group which is spatially closest to the target node.
##
## If there is no such node, e.g. if the group is empty, the result will be null.
static func closest_in_group(target: Node3D, group_name: String) -> Node3D:
	var closest: Node3D
	var min_dist_sq := INF
	for n: Node in target.get_tree().get_nodes_in_group(group_name):
		if n is Node3D:
			var dist_sq := (n as Node3D).global_position.distance_squared_to(target.global_position)
			if dist_sq < min_dist_sq:
				min_dist_sq = dist_sq
				closest = n
	return closest
